<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: rss_parser_panel_admin.php for RSS Parser System
| Author: Stewart-G0LGS (A G S Wilkinson)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+
| Note: This Package includes other works distributed under
| GNU General Public License (GPL) as published by
| the Free Software Foundation
+--------------------------------------------------------*/

require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

include INFUSIONS."rss_parser_panel/infusion_db.php";

if (!checkrights("RSP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("/index.php"); }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."rss_parser_panel/locale/English.php";
}

if( isset($_GET['status']) ) {
	$status=stripinput($_GET['status']);
	if ( $status == "sn") {
		$message = $locale['rssp_sn'];
	} elseif ( $status == "su") {
		$message = $locale['rssp_su'];
	} elseif ( $status == "cl") {
		$message = $locale['rssp_cl'];
	} elseif ( $status == "dl") {
		$message = $locale['rssp_dl'];
	}
	if ($message) { echo "<div class='admin-message'>".$message."</div>\n"; }
}

//
// Please DO NOT remove this Section. It is the only place in
// my work that displays my information and a link for you the
// PHP-Fusion System Administrator to be able to easily find the 
// latest Version or any extra information that I may publish
// about the RSS Parser System.
// 

opentable("RSS Parser System V".$rssp_version." (".$rssp_verdate.")");
echo "<table>\n";
echo "<tr><td>Copyright &copy; 2011 by Stewart Wilkinson G0LGS (";
echo hide_email('php@g0lgs.co.uk','','RSS-Parser-System').")</td></tr>\n";

echo "<tr><td>See: <a href='http://www.g0lgs.co.uk/soft_vers.php?AppName=rssparser&amp;Vers=";
echo $rssp_version."' target='_blank'>http://www.g0lgs.co.uk</a>";
echo " for updates.</td></tr>\n";

if( ! is_writable( INFUSIONS."rss_parser_panel/cache/" ) ){

	$msg = str_replace("[CACHE_FOLDER]", "/infusions/rss_parser_panel/cache/", $locale['rssp_150']);
	echo "<tr><td style='color:red;'><strong>".$msg."</strong></td></tr>\n";	
}else{
	echo "<tr><td style='color:green;'><strong>".$locale['rssp_151']."</strong></td></tr>\n";	
}
echo "</table>\n";
closetable(); 

if(isset($_GET['action'])) {
	$action = stripinput($_GET['action']);
} else {
	$action = '';
}

if( $action == 'clear' ){
	if( isset($_GET['feed_id']) ){
		$feed_id = stripinput($_GET['feed_id']);

		// Get Feed info from DB
		$rssp_res = dbquery("SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

		if( dbrows($rssp_res) != 0 ){
			// Get Row Info
			$rssp_data = dbarray($rssp_res);

			$cachefile = INFUSIONS."rss_parser_panel/cache/rsscache_" . md5($rssp_data['feed_url']);
			if( file_exists( $cachefile ) ) {
				if( unlink( $cachefile ) ){
					$rssp_status="&amp;status=cl";
				}
			}
		}
	}
	// Refresh Page
	redirect(FUSION_SELF.$aidlink.$rssp_status);

}elseif( $action == 'clearall' ){
	
	$cachefiles = INFUSIONS."rss_parser_panel/cache/rsscache_*";
	foreach( glob($cachefiles) as $fn) {
		unlink($fn);
	} 

	// Redirect
	$rssp_status="&amp;status=cl";
	redirect(FUSION_SELF.$aidlink.$rssp_status);

//
// Delete Feed from List / Remove Cache / Remove Related Panels
//
}elseif( $action == 'delete' ){
	if( isset($_GET['feed_id']) ){
		$feed_id = stripinput($_GET['feed_id']);

		// Get Feed info from DB
		$rssp_res = dbquery("SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

		if( dbrows($rssp_res) != 0 ){
			// Get Row Info
			$rssp_data = dbarray($rssp_res);
			$rssp_name = $rssp_data['feed_name'];

			// Remove Cache
			$cachefile = INFUSIONS."rss_parser_panel/cache/rsscache_" . md5($rssp_data['feed_url']);
			if( file_exists( $cachefile ) ) {
				unlink( $cachefile );
			}

			// Drop Feed from DB
			$result = dbquery("DELETE FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

			// Drop Related Panels
			if( $rssp_name and ($rssp_name != '') ){
				$rssp_res = dbquery( "DELETE FROM ".DB_PANELS." WHERE panel_name='".$rssp_name."' AND panel_filename = 'rss_parser_panel'" );
			}

			if( $result ){
				$rssp_status="&amp;status=dl";
			}
		}
	}
	// Refresh Page
	redirect(FUSION_SELF.$aidlink.$rssp_status);

}else{
	if (isset($_POST['save_feed'])) {
		$feed_name = stripinput($_POST['feed_name']);
		$feed_url  = stripinput($_POST['feed_url']);
		$link_name = stripinput($_POST['link_name']);
		$feed_rows = stripinput($_POST['feed_rows']);
		$cache_time= stripinput($_POST['cache_time']);
		$new_window= isset($_POST['new_window']) ? 1:0;
		$panel_loc= stripinput($_POST['location']);
		$panel_acc= stripinput($_POST['access']);

		if ($action == 'edit') {
			$feed_id = stripinput($_POST['feed_id']);

			// GET Old Panel Name
			$rssp_res = dbquery( "SELECT feed_name FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );
			$rssp_data = dbarray($rssp_res);
			$rssp_pname = $rssp_data['feed_name'];

			// Rename Panel ??
			if( $feed_name != $rssp_pname ){
				$SQL1 = "UPDATE ".DB_PANELS." SET
					panel_name = '".$feed_name."'
					WHERE panel_name = '".$rssp_pname."' AND panel_filename = 'rss_parser_panel'";
			}

			$SQL2 = "UPDATE ".DB_RSSPANEL." SET
				feed_name = '".$feed_name."',
				feed_url = '".$feed_url."',
				feed_linkname = '".$link_name."',
				feed_rows = '".$feed_rows."',
				feed_cache = '".$cache_time."',
				feed_newwin = '".$new_window."'
				WHERE feed_id='".$feed_id."'";

			if( ($result = dbquery($SQL2) ) ) {
				if( $SQL1 ){
					$result2 = dbquery($SQL1);
				}
			}

			if( $result ){
				$rssp_status="&amp;status=su";
			}
			
			unset($action);

			// Refresh Page
			redirect(FUSION_SELF.$aidlink.$rssp_status);

		} else {

			// Add New Feed
			$SQL = "INSERT INTO ".DB_RSSPANEL." 
				(feed_name, feed_url, feed_linkname, feed_rows, feed_cache, feed_newwin )
				VALUES
				('$feed_name', '$feed_url', '$link_name', '$feed_rows', '$cache_time', '$new_window' )";

			$result = dbquery($SQL);

			// Find new Panel Order
			$SQL = "SELECT * FROM ".DB_PANELS." WHERE panel_side='".$panel_loc."' ORDER BY panel_order DESC LIMIT 1";
			$rssp_res = dbquery($SQL);

			if (dbrows($rssp_res) != 0) { 
				$rssp_data = dbarray($rssp_res); 
				$rssp_newpos = $rssp_data['panel_order'] + 1; 
			} else { 
				$rssp_newpos = 1; 
			}

			// Create New Panel
			$SQL = "INSERT INTO ".DB_PANELS."
			        (panel_name, panel_filename, panel_content, panel_side, panel_order, panel_type, panel_access, panel_display, panel_status)
			        VALUES ('$feed_name', 'rss_parser_panel', '', '$panel_loc', '$rssp_newpos', 'file', '$panel_acc', '0', '1')";

			$result = dbquery($SQL);

			if( $result ){
				$rssp_status="&amp;status=sn";
			}
			// Refresh Page
			redirect(FUSION_SELF.$aidlink.$rssp_status);
		}

	}

	if( $action == 'edit' ){

		if( isset($_GET['feed_id'] ) ){
			$feed_id = stripinput($_GET['feed_id']);
		}else{
			redirect(FUSION_SELF.$aidlink);
		}

		// GET Panel Information
		$rssp_res = dbquery( "SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );
		$rssp_data = dbarray($rssp_res);

		$rss_formaction = FUSION_SELF.$aidlink."&action=edit";

		$feed_name = $rssp_data['feed_name'];
		$feed_url = $rssp_data['feed_url'];
		$link_name = $rssp_data['feed_linkname'];
		$feed_rows = $rssp_data['feed_rows'];
		$cache_time = $rssp_data['feed_cache'];
		$new_window = $rssp_data['feed_newwin'] ? "checked='checked'" : "";

		// Get Current Panel Location / Access
		$rssp_res = dbquery( "SELECT * FROM ".DB_PANELS." WHERE panel_name='".$feed_name."' AND panel_filename = 'rss_parser_panel'" );
		$rssp_data = dbarray($rssp_res);
		$loc = $rssp_data['panel_side'];
		$access = $rssp_data['panel_access'];

		$readonly = " disabled='disabled'";
		$noedit = str_replace("[PANEL_EDITOR]", "<a href='/administration/panels.php".$aidlink
		."'>".$locale['rssp_131']."</a>", $locale['rssp_noedit']);

		opentable($locale['rssp_edit']);

	}else{
		$rss_formaction = FUSION_SELF.$aidlink;
		$feed_name='';
		$feed_url='http://';
		$link_name='';
		$feed_rows='5';
		$cache_time='3600';
		$new_window=" checked='checked'";
		$loc=1;		// Left Panel
		$access=102;	// Admin
		$readonly='';
		$noedit='';

		opentable($locale['rssp_add']);
	}

	$loc1 = ($loc==1) ? " selected='selected'" :"";
	$loc2 = ($loc==2) ? " selected='selected'" :"";
	$loc3 = ($loc==3) ? " selected='selected'" :"";
	$loc4 = ($loc==4) ? " selected='selected'" :"";

	$acc1 = ($access==0) ? " selected='selected'" :"";
	$acc2 = ($access==101) ? " selected='selected'" :"";
	$acc3 = ($access==102) ? " selected='selected'" :"";
	$acc4 = ($access==103) ? " selected='selected'" :"";

	echo "<form name='addfeed' method='post' action='".$rss_formaction."'>\n";

	if( ($action == 'edit') and $feed_id ){
		echo "<input type='hidden' name='feed_id' value='".$feed_id."'>\n";
	}

	echo "<table align='center' cellspacing='1' cellpadding='0' class='tbl-border'>\n";

	echo "	<tr>
		<td class='tbl1'>".$locale['rssp_120']."</td>
		<td class='tbl1'><input type='text' name='feed_name' maxlength='30' value='".$feed_name."' class='textbox' style='width:150px;' title='".$locale['rssp_120b']."'></td>
		<td class='tbl1'>".$locale['rssp_120a']."</td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_121']."</td>
		<td class='tbl1' colspan='2'><input type='text' name='feed_url' maxlength='100' value='".$feed_url."' class='textbox' style='width:350px;'title='".$locale['rssp_121b']."'></td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_122']."</td>
		<td class='tbl1'><input type='text' name='link_name' maxlength='30' value='".$link_name."' class='textbox' style='width:120px;' title='".$locale['rssp_122b']."'></td>
		<td class='tbl1'>".$locale['rssp_122a']."</td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_123']."</td>
		<td class='tbl1'><input type='text' size='3' maxlength='2' name='feed_rows' value='".$feed_rows."' class='textbox' title='".$locale['rssp_123b']."'></td>
		<td class='tbl1'>".$locale['rssp_123a']."</td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_124']."</td>
		<td class='tbl1'><input type='text' size='5' maxlength='5' name='cache_time' value='".$cache_time."' class='textbox' title='".$locale['rssp_124b']."'> Seconds</td>
		<td class='tbl1'>".$locale['rssp_124a']."</td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_125']."</td>
		<td class='tbl1' colspan='2'><input type='checkbox' name='new_window' class='textbox' value='1' ".$new_window."title='".$locale['rssp_125b']."'></td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_126']."</td>
		<td class='tbl1'>
			<select name='location' class='textbox'".$readonly." title='".$locale['rssp_126b']."'>
			<option value='1' ".$loc1.">Left</option>
			<option value='2' ".$loc2.">U-Ctr</option>
			<option value='3' ".$loc3.">L-Ctr</option>
			<option value='4' ".$loc4.">Right</option>
			</select>
		</td>
		<td  class='tbl1'>".$noedit."<td>
		</tr>

		<tr>
		<td class='tbl1'>".$locale['rssp_127']."</td>
		<td class='tbl1'>
			<select name='access' class='textbox'".$readonly." title='".$locale['rssp_127b']."'>
			<option value='0'   ".$acc1.">Public</option>
			<option value='101' ".$acc2.">Member</option>
			<option value='102' ".$acc3.">Admin</option>
			<option value='103' ".$acc4.">Super-Admin</option>
			</select>
		</td>
		<td  class='tbl1'>".$noedit."<td>
		</tr>

		<tr align='center'>
		<td class='tbl1' colspan='3'><input type='submit' name='save_feed' value='".$locale['rssp_b1']."' class='button'></td>
		</tr>
	";

	echo "</table>\n";
	echo "</form>\n";

	closetable();
}

// Get Existing Feeds from DB
$rssp_res = dbquery("SELECT * FROM ".DB_RSSPANEL );

// Not Found
if( !$rssp_res ) {
	opentable($locale['rssp_100']);
	echo "<p>".$locale['rssp_101']."</p>"; 
	closetable(); 
}

if (dbrows($rssp_res) == 0){
	opentable($locale['rssp_100']);
	echo "<p>".$locale['rssp_101']."</p>"; 
	closetable(); 

// Display Feed Info
}else{
	opentable($locale['rssp_100']);

	echo "<table align='center' width='400' cellspacing='1' cellpadding='0' class='tbl-border'>\n";

	echo "<tr>\n";
	echo "<td class='tbl2'>".$locale['rssp_102']."</td>\n";
	echo "<td class='tbl2' colspan='3' style='text-align:center'>".$locale['rssp_103']."</td>\n";
	echo "</tr>\n";

	while( $rssp_data = dbarray($rssp_res) ){

		$edit_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=edit&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_107']." \"".$rssp_data['feed_name']."\"'>".$rssp_data['feed_name']."</a>";

		$view_url = "<a href='".$rssp_data['feed_url']."' target='_blank' "
		." title='".$locale['rssp_104']." \"".$rssp_data['feed_name']."\"'>".$locale['rssp_104']."</a>";

		$clear_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=clear&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_105']." \"".$rssp_data['feed_name']."\"'>".$locale['rssp_105']."</a>";

		$delete_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_106']." \"".$rssp_data['feed_name']."\"'>".$locale['rssp_106']."</a>";

		echo "<tr>\n";
		echo "<td class='tbl1'>".$edit_url."</td>\n";
		echo "<td class='tbl1'>".$view_url."</td>\n";
		echo "<td class='tbl1'>".$clear_url."</td>\n";
		echo "<td class='tbl1'>".$delete_url."</td>\n";
		echo "</tr>\n";
	}

	$clear_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=clearall"
	."' title='".$locale['rssp_105']."'>".$locale['rssp_105']."</a>";

	echo "<tr><td colspan='4'><hr></td></tr>\n";
	echo "<tr><td class='tbl1'>".$locale['rssp_110']."</td>\n";
	echo "<td class='tbl1'>&nbsp;</td><td class='tbl1'>".$clear_url."</td>\n";
	echo "<td class='tbl1'>&nbsp;</td></tr>\n";

	echo "</table>\n";

	closetable(); 
}

require_once THEMES."templates/footer.php";

?>
